<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class Sm00001001DocumentoPropostaFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getDocumentoProposta()
    {
        $sql = "SELECT ORCADOC.NRSEQORCADOC,
                        ORCADOC.NRSEQORCAMENTO,
                        ORC.NRORCAMENTO || ' - ' || ORC.DSREFERENCIAORCA AS NMPROPOSTA,
                        ORC.IDSITUACAOORCAMENTO AS IDSITUACAOATUALORCAMENTO,
                        ORC.NRPARCNEGOCIO,
                        PARC.NMPRINCIPALPARC,
                        ORCADOC.NRSEQMODDOCFCT,
                        MODELO.DSMODELODOCORCA,
                        ORCADOC.NRORG,
                        ORCADOC.IDATIVO,
                        ORCADOC.DTINCLUSAO,
                        ORCADOC.DTULTATU,
                        ORCADOC.NRORGINCLUSAO,
                        ORCADOC.CDOPERINCLUSAO,
                        ORCADOC.NRORGULTATU,
                        ORCADOC.CDOPERULTATU,
                        ORCADOC.NMARQUIVO,
                        ORCADOC.DSCAMINHOARQ,
                        ORCADOC.DSTIPO,
                        ORCADOC.VRTAMANHO,
                        ORCADOC.NRTIPOORCAMENTO,
                        ESCOPO.NMTIPOORCAMENTO,
                        ORCADOC.DSCAMINHODOCGERADOPDF,
                        ORCADOC.IDDOCALTERADO,
                        ORCADOC.VRTAMANHOLOGO,
                        ORCADOC.IDDOCUMCERTSIGN,
                        ORCADOC.CHAVEDOCUMCERTSIGN,
                        LISTAGG(SITU.IDSITUACAOORCAMENTO, ',') WITHIN GROUP(
                                                                            ORDER BY SITU.IDSITUACAOORCAMENTO) AS IDSITUACAOORCAMENTO
                FROM FCT_ORCAMENTODOC ORCADOC
                INNER JOIN FCT_ORCAMENTO ORC ON ORCADOC.NRSEQORCAMENTO = ORC.NRSEQORCAMENTO
                INNER JOIN PARCNEGOCIO PARC ON ORC.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                LEFT JOIN FCT_MODELODOC MODELO ON ORCADOC.NRSEQMODDOCFCT = MODELO.NRSEQMODDOCFCT
                INNER JOIN FCT_ORCAMENTODOCSITU SITU ON ORCADOC.NRSEQORCADOC = SITU.NRSEQORCADOC
                INNER JOIN FCT_TIPOORCAMENTO ESCOPO ON ORCADOC.NRTIPOORCAMENTO = ESCOPO.NRTIPOORCAMENTO
                GROUP BY ORCADOC.NRSEQORCADOC,
                        ORCADOC.NRSEQORCAMENTO,
                        ORC.NRORCAMENTO,
                        ORC.DSREFERENCIAORCA,
                        ORC.IDSITUACAOORCAMENTO,
                        ORC.NRPARCNEGOCIO,
                        PARC.NMPRINCIPALPARC,
                        ORCADOC.NRSEQMODDOCFCT,
                        MODELO.DSMODELODOCORCA,
                        ORCADOC.NRORG,
                        ORCADOC.IDATIVO,
                        ORCADOC.DTINCLUSAO,
                        ORCADOC.DTULTATU,
                        ORCADOC.NRORGINCLUSAO,
                        ORCADOC.CDOPERINCLUSAO,
                        ORCADOC.NRORGULTATU,
                        ORCADOC.CDOPERULTATU,
                        ORCADOC.NMARQUIVO,
                        ORCADOC.DSCAMINHOARQ,
                        ORCADOC.DSTIPO,
                        ORCADOC.VRTAMANHO,
                        ORCADOC.NRTIPOORCAMENTO,
                        ESCOPO.NMTIPOORCAMENTO,
                        ORCADOC.DSCAMINHODOCGERADOPDF,
                        ORCADOC.IDDOCALTERADO,
                        ORCADOC.VRTAMANHOLOGO,
                        ORCADOC.IDDOCUMCERTSIGN,
                        ORCADOC.CHAVEDOCUMCERTSIGN";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, [], [], null, null, null, array('IDSITUACAOORCAMENTO'));
    }

    public function getProposta()
    {
        $sql = "SELECT  NRSEQORCAMENTO, NRORCAMENTO || ' - ' || DSREFERENCIAORCA AS NMPROPOSTA
                FROM FCT_ORCAMENTO";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTabAnexoDocumentoProposta(array $params)
    {
        $sql = "SELECT DOCIDIOMA.NRORCAMENTODOCIDIOMA,
                        DOCIDIOMA.NRSEQORCADOC,
                        DOCIDIOMA.CDIDIOM,
                        IDIOMA.NMIDIOMA,
                        IDIOMA.IDPADRAO,
                        DOCIDIOMA.NMARQUIVO,
                        DOCIDIOMA.DSCAMINHOARQ,
                        DOCIDIOMA.DSTIPO,
                        DOCIDIOMA.VRTAMANHO,
                        DOCIDIOMA.IDATIVO,
                        DOCIDIOMA.NRORG,
                        DOCIDIOMA.DTINCLUSAO,
                        DOCIDIOMA.NRORGINCLUSAO,
                        DOCIDIOMA.CDOPERINCLUSAO,
                        DOCIDIOMA.DTULTATU,
                        DOCIDIOMA.NRORGULTATU,
                        DOCIDIOMA.CDOPERULTATU
                FROM FCT_ORCAMENTODOCIDIOMA DOCIDIOMA
                INNER JOIN IDIOMA ON DOCIDIOMA.CDIDIOM = IDIOMA.CDIDIOM
                WHERE DOCIDIOMA.NRSEQORCADOC = :NRSEQORCADOC";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getPropostasDocumento($parametro)
    {
        $sql = "SELECT ORC.NRSEQORCAMENTO,
                ORC.NRORCAMENTO || ' - ' || ORC.DSREFERENCIAORCA AS NMPROPOSTA,
                PARC.NMPRINCIPALPARC, 
                ORC.IDSITUACAOORCAMENTO AS IDSITUACAOATUALORCAMENTO
                FROM FCT_ORCAMENTO ORC
                LEFT JOIN PARCNEGOCIO PARC ON ORC.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametro);
    }

    public function inserirDocumentoProposta(array $params)
    {
        $sql = "INSERT INTO FCT_ORCAMENTODOC (
            NRSEQORCADOC,       NRSEQORCAMENTO,      NRTIPOORCAMENTO,
            VRTAMANHOLOGO,      NRSEQMODDOCFCT,      IDATIVO,             
            DTINCLUSAO
        )
        VALUES (
            :NRSEQORCADOC,      :NRSEQORCAMENTO,     :NRTIPOORCAMENTO,
            :VRTAMANHOLOGO,     :NRSEQMODDOCFCT,     :IDATIVO,            
            SYSDATE       
        )";

        $this->connection->executeStatement($sql, $params);
    }

    public function inserirSituacaoDocumentoProposta(array $params)
    {
        $sql = "INSERT INTO FCT_ORCAMENTODOCSITU (
            NRORCAMENTODOCSITU,  IDSITUACAOORCAMENTO,  NRSEQORCADOC,  
            IDATIVO,            NRORG,                 DTINCLUSAO,         
            NRORGINCLUSAO,      CDOPERINCLUSAO         
            )
        VALUES (
            :NRORCAMENTODOCSITU, :IDSITUACAOORCAMENTO, :NRSEQORCADOC,
            :IDATIVO,            :NRORG,               SYSDATE,            
            :NRORGINCLUSAO,      :CDOPERINCLUSAO      
        )";

        $this->connection->executeStatement($sql, $params);
    }

    public function updateDocumentoProposta(array $params)
    {
        $sql = "UPDATE FCT_ORCAMENTODOC 
        SET VRTAMANHOLOGO = :VRTAMANHOLOGO, 
        CDOPERULTATU = :CDOPERULTATU
        WHERE NRSEQORCADOC = :NRSEQORCADOC";
        $this->connection->executeStatement($sql, $params);
    }

    public function excluirSituacoesDocumentoProposta(array $params)
    {
        $sql = "DELETE FROM FCT_ORCAMENTODOCSITU
                 WHERE NRSEQORCADOC = :NRSEQORCADOC";

        $this->connection->executeStatement($sql, $params);
    }

    public function inserirSituacoesDocumentoProposta(array $params)
    {
        $sql = "INSERT INTO FCT_ORCAMENTODOCSITU (
                    NRORCAMENTODOCSITU,  NRSEQORCADOC,   IDSITUACAOORCAMENTO,
                    IDATIVO,             NRORG,          DTINCLUSAO,
                    NRORGINCLUSAO,       CDOPERINCLUSAO
                )
                VALUES (
                    :NRORCAMENTODOCSITU,  :NRSEQORCADOC,   :IDSITUACAOORCAMENTO,
                    :IDATIVO,             :NRORG,          SYSDATE,
                    :NRORGINCLUSAO,       :CDOPERINCLUSAO
                )";

        $this->connection->executeStatement($sql, $params);
    }

    public function getEscopoFaturamento($parametro)
    {
        $sql = "SELECT DISTINCT RELAC.NRRELACESCOPOPROPOSTA,
                        RELAC.NRSEQORCAMENTO,
                        RELAC.NRTIPOORCAMENTO,
                        TIPO.NMTIPOORCAMENTO
                FROM FCT_RELACESCOPOPROPOSTA RELAC
                INNER JOIN FCT_TIPOORCAMENTO TIPO ON RELAC.NRTIPOORCAMENTO = TIPO.NRTIPOORCAMENTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametro);
    }

    public function deleteDocumentoProposta($params)
    {
        $sql = "DELETE FROM FCT_ORCAMENTODOC WHERE NRSEQORCADOC = :NRSEQORCADOC";
        $this->connection->executeStatement($sql, $params);
    }

    public function validaDocPropIdioma($params)
    {

        $sql = "SELECT COUNT (*) AS QTD 
                FROM FCT_ORCAMENTODOCIDIOMA
                WHERE NRSEQORCADOC    = :NRSEQORCADOC
                AND CDIDIOM           = :CDIDIOM
                AND NRORCAMENTODOCIDIOMA <> NVL(:NRORCAMENTODOCIDIOMA, -1)";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

    public function inserirModeloDocumentoProposta($parametros)
    {
        $sql = "INSERT INTO FCT_ORCAMENTODOCIDIOMA (
                    NRORCAMENTODOCIDIOMA,   NRSEQORCADOC,          CDIDIOM,
                    IDATIVO,                NMARQUIVO,              DSCAMINHOARQ,           
                    DSTIPO,                 VRTAMANHO,              NRORG,                  
                    NRORGINCLUSAO,          CDOPERINCLUSAO,         DTINCLUSAO           
                    )
                    VALUES(
                    :NRORCAMENTODOCIDIOMA,  :NRSEQORCADOC,         :CDIDIOM,
                    :IDATIVO,               :NMARQUIVO,             :DSCAMINHOARQ,          
                    :DSTIPO,                :VRTAMANHO,             :NRORG,                 
                    :NRORGINCLUSAO,         :CDOPERINCLUSAO,        SYSDATE
                    )";
        $this->connection->executeStatement($sql, $parametros);
    }

    public function updateModeloDocumentoProposta($parametros)
    {
        $sql = "UPDATE FCT_ORCAMENTODOCIDIOMA
                SET NRSEQORCADOC = :NRSEQORCADOC,
                        CDIDIOM     = :CDIDIOM,
                        IDATIVO = :IDATIVO,
                        NMARQUIVO = :NMARQUIVO,
                        DSCAMINHOARQ = :DSCAMINHOARQ,
                        DSTIPO = :DSTIPO,
                        VRTAMANHO = :VRTAMANHO,
                        CDOPERULTATU = :CDOPERULTATU,
                        NRORGULTATU = :NRORGULTATU,
                        DTULTATU = SYSDATE
                WHERE NRORCAMENTODOCIDIOMA = :NRORCAMENTODOCIDIOMA";
        $this->connection->executeStatement($sql, $parametros);
    }

    public function getAnexoProposta(array $params)
    {
        $sql = "SELECT NMARQUIVO,
                  VRTAMANHO,
                  DSCAMINHOARQ,
                  DSTIPO
                FROM FCT_ORCAMENTODOCIDIOMA
                WHERE NRORCAMENTODOCIDIOMA = :NRORCAMENTODOCIDIOMA";

         return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getDocumentoPropostaIdioma(array $params)
    {
        $sql = "SELECT *FROM FCT_ORCAMENTODOCIDIOMA
                 WHERE NRORCAMENTODOCIDIOMA = :NRORCAMENTODOCIDIOMA";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function deletarAnexoDocumentoProposta($params)
    {
        $sql = "DELETE FROM FCT_ORCAMENTODOCIDIOMA
                WHERE NRORCAMENTODOCIDIOMA = :NRORCAMENTODOCIDIOMA";
        $this->connection->executeStatement($sql, $params);
    }

    public function limparAnexoModeloDocumentoProposta(array $params)
    {
        $sql = "UPDATE FCT_ORCAMENTODOCIDIOMA
                   SET DSCAMINHOARQ = NULL,
                       NMARQUIVO    = NULL,
                       VRTAMANHO    = NULL,
                       DSTIPO       = NULL
                 WHERE NRORCAMENTODOCIDIOMA = :NRORCAMENTODOCIDIOMA";
        $this->connection->executeStatement($sql, $params);
    }

    public function getAnexoDocumentoProposta(array $params)
    {
        $sql = "SELECT NRSEQORCADOC,
                       TXMODELOORCADOC,
                       NMARQUIVO,
                       DSCAMINHOARQ,
                       DSTIPO,
                       VRTAMANHO
                  FROM FCT_ORCAMENTODOC
                 WHERE INSTR(:NRSEQORCADOC, '_' || TO_CHAR(NRSEQORCADOC) || '_') > 0
                   AND NRORG = :NRORG";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function limparAnexoDaProposta(array $params)
    {
        $sql = "UPDATE FCT_ORCAMENTODOC
                   SET NMARQUIVO     = NULL,
                       DSCAMINHOARQ  = NULL,
                       DSTIPO        = NULL,
                       VRTAMANHO     = NULL,
                       IDDOCALTERADO = 'S'
                 WHERE INSTR(:NRSEQORCADOC, '_' || TO_CHAR(NRSEQORCADOC) || '_') > 0
                   AND NRORG        = :NRORG";
        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarCaminhoDocumentoProposta(array $params)
    {
        $sql = "UPDATE FCT_ORCAMENTODOC
                   SET DSCAMINHOARQ = :DSCAMINHOARQ,
                       DTULTATU     = SYSDATE,
                       CDOPERULTATU = :CDOPERULTATU,
                       NRORGULTATU  = :NRORGULTATU
                 WHERE INSTR(:NRSEQORCADOC, '_' || TO_CHAR(NRSEQORCADOC) || '_') > 0
                   AND NRORG        = :NRORG";
        $this->connection->executeStatement($sql, $params);
    }
}
